/* "picture0.c" */

typedef unsigned char UCHAR;

struct DLL_STRPICENV {
	int error, errp, reserve[6];
};

int info_BMP(struct DLL_STRPICENV *env, int *info, int size, UCHAR *fp);
int decode0_BMP(struct DLL_STRPICENV *env, int size, UCHAR *fp, int b_type, UCHAR *buf, int skip);
int decode0_BMPpart(struct DLL_STRPICENV *env,int xsz,int ysz,int x,int y,int size,UCHAR*fp,int btype,UCHAR*buf,int skip);

int info_JPEG(struct DLL_STRPICENV *env, int *info, int size, UCHAR *fp);
int decode0_JPEG(struct DLL_STRPICENV *env, int size, UCHAR *fp, int b_type, UCHAR *buf, int skip);
int decode0_JPEGpart(struct DLL_STRPICENV *env,int xsz,int ysz,int x,int y,int size,UCHAR*fp,int btype,UCHAR*buf,int skip);

int info_PNG(struct DLL_STRPICENV *env, int *info, int size, UCHAR *fp);
int decode0_PNG(struct DLL_STRPICENV *env, int size, UCHAR *fp, int b_type, UCHAR *buf, int skip);
int decode0_PNGpart(struct DLL_STRPICENV *env,int xsz,int ysz,int x,int y,int size,UCHAR*fp,int btype,UCHAR*buf,int skip);

int info_ICO(struct DLL_STRPICENV *env, int *info, int size, UCHAR *fp);
int decode0_ICO(struct DLL_STRPICENV *env, int size, UCHAR *fp, int b_type, UCHAR *buf, int skip);
int decode0_ICOpart(struct DLL_STRPICENV *env,int xsz,int ysz,int x,int y,int size,UCHAR*fp,int btype,UCHAR*buf,int skip);

int *cmd_init(struct DLL_STRPICENV *env, int *cmd);
int *cmd_info(struct DLL_STRPICENV *env, int *cmd);
int *cmd_decode(struct DLL_STRPICENV *env, int *cmd);
int *cmd_decodepart(struct DLL_STRPICENV *env, int *cmd);

int *DllMain(struct DLL_STRPICENV *env, int *cmd)
{
	env->error = 0;
	env->errp = 0;
	while (*cmd != 0x0000) {
		/* switchgƂGOWve[u邩Ȃ̂
			idataZNV肻Ȃ̂Łj߂ */
		if (*cmd == 0x0001) {
			cmd = cmd_init(env, cmd);
			continue;
		}
		if (*cmd == 0x0002) {
			cmd = cmd_info(env, cmd);
			continue;
		}
		if (*cmd == 0x0004) {
			cmd = cmd_decode(env, cmd);
			if (env->error)
				goto error;
			continue;
		}
		if (*cmd == 0x0005) {
			cmd = cmd_decodepart(env, cmd);
			if (env->error)
				goto error;
			continue;
		}
		env->error = 1; /* func-code-error */
error:
		env->errp = (int) cmd;
		break;
	}
	return cmd;
}

int *cmd_init(struct DLL_STRPICENV *env, int *cmd)
{
	return cmd + 2;
}

int *cmd_info(struct DLL_STRPICENV *env, int *cmd)
{
	/* ʓ|Ȃ̂ōhintΉ */
	int *info = (int *) cmd[2];
	if (info_BMP(env, info, cmd[3], (UCHAR *) cmd[4]))
		goto fin;
	if (info_JPEG(env, info, cmd[3], (UCHAR *) cmd[4]))
		goto fin;
	if (info_PNG(env, info, cmd[3], (UCHAR *) cmd[4]))
		goto fin;
        if (info_ICO(env, info, cmd[3], (UCHAR *) cmd[4]))
                goto fin;
	info[0] = 0x0000; /* unknown */
fin:
	return cmd + 6;
}

int *cmd_decode(struct DLL_STRPICENV *env, int *cmd)
{
	env->error = 2; /* func-param-error */
	if (cmd[2] == 0x0001)
		env->error = decode0_BMP(env, cmd[3], (UCHAR *) cmd[4], cmd[5], (UCHAR *) cmd[6], cmd[7]);
	if (cmd[2] == 0x0002)
		env->error = decode0_JPEG(env, cmd[3], (UCHAR *) cmd[4], cmd[5], (UCHAR *) cmd[6], cmd[7]);
	if (cmd[2] == 0x0003)
		env->error = decode0_PNG(env, cmd[3], (UCHAR *) cmd[4], cmd[5], (UCHAR *) cmd[6], cmd[7]);
        if (cmd[2] == 0x0004)
                env->error = decode0_ICO(env, cmd[3], (UCHAR *) cmd[4], cmd[5], (UCHAR *) cmd[6], cmd[7]);
 	return cmd + 8;
}

int *cmd_decodepart(struct DLL_STRPICENV *env, int *cmd)
{
	env->error = 2; /* func-param-error */
	/* xsz, ysz, x0, y0, size, fp, b_type, buf, skip */
	if (cmd[2] == 0x0001)
	    env->error = decode0_BMPpart(env, cmd[3], cmd[4], cmd[5], cmd[6],
	        cmd[7], (UCHAR*)cmd[8], cmd[9], (UCHAR*)cmd[10], cmd[11]);
	if (cmd[2] == 0x0002)
	    env->error = decode0_JPEGpart(env, cmd[3],cmd[4], cmd[5], cmd[6],
	        cmd[7], (UCHAR*)cmd[8], cmd[9], (UCHAR*)cmd[10], cmd[11]);
	if (cmd[2] == 0x0003)
	    env->error = decode0_PNGpart(env, cmd[3],cmd[4], cmd[5], cmd[6],
	        cmd[7], (UCHAR*)cmd[8], cmd[9], (UCHAR*)cmd[10], cmd[11]);
        if (cmd[2] == 0x0004)
            env->error = decode0_ICOpart(env, cmd[3],cmd[4], cmd[5], cmd[6],
                cmd[7], (UCHAR*)cmd[8], cmd[9], (UCHAR*)cmd[10], cmd[11]);
	return cmd + 12;
}
